=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.3.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require "uri"

module NSXT
  class AppDiscoveryApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end

    # Adds a new app profile
    # Adds a new app profile 
    # @param app_profile 
    # @param [Hash] opts the optional parameters
    # @return [AppProfile]
    def add_app_profile(app_profile, opts = {})
      data, _status_code, _headers = add_app_profile_with_http_info(app_profile, opts)
      return data
    end

    # Adds a new app profile
    # Adds a new app profile 
    # @param app_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppProfile, Fixnum, Hash)>] AppProfile data, response status code and response headers
    def add_app_profile_with_http_info(app_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.add_app_profile ..."
      end
      # verify the required parameter 'app_profile' is set
      if @api_client.config.client_side_validation && app_profile.nil?
        fail ArgumentError, "Missing the required parameter 'app_profile' when calling AppDiscoveryApi.add_app_profile"
      end
      # resource path
      local_var_path = "/app-discovery/app-profiles"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(app_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#add_app_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Cancel and delete the application discovery session
    # Cancel and delete the application discovery session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [nil]
    def delete_app_discovery_session(session_id, opts = {})
      delete_app_discovery_session_with_http_info(session_id, opts)
      return nil
    end

    # Cancel and delete the application discovery session
    # Cancel and delete the application discovery session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_app_discovery_session_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.delete_app_discovery_session ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.delete_app_discovery_session"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#delete_app_discovery_session\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete App Profile
    # Deletes the specified AppProfile. 
    # @param app_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere  (default to false)
    # @return [nil]
    def delete_app_profile(app_profile_id, opts = {})
      delete_app_profile_with_http_info(app_profile_id, opts)
      return nil
    end

    # Delete App Profile
    # Deletes the specified AppProfile. 
    # @param app_profile_id 
    # @param [Hash] opts the optional parameters
    # @option opts [BOOLEAN] :force Force delete the resource even if it is being used somewhere 
    # @return [Array<(nil, Fixnum, Hash)>] nil, response status code and response headers
    def delete_app_profile_with_http_info(app_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.delete_app_profile ..."
      end
      # verify the required parameter 'app_profile_id' is set
      if @api_client.config.client_side_validation && app_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_profile_id' when calling AppDiscoveryApi.delete_app_profile"
      end
      # resource path
      local_var_path = "/app-discovery/app-profiles/{app-profile-id}".sub('{' + 'app-profile-id' + '}', app_profile_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'force'] = opts[:'force'] if !opts[:'force'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#delete_app_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns the status of the application discovery session and other details
    # Returns the status of the application discovery session and other details 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [AppDiscoverySession]
    def get_app_discovery_session(session_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_with_http_info(session_id, opts)
      return data
    end

    # Returns the status of the application discovery session and other details
    # Returns the status of the application discovery session and other details 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDiscoverySession, Fixnum, Hash)>] AppDiscoverySession data, response status code and response headers
    def get_app_discovery_session_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoverySession')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # application profiles in this application discovery session
    # Returns the application profiles that was part of the application discovery session | while it was started. 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [AppProfileListResult]
    def get_app_discovery_session_app_profiles(session_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_app_profiles_with_http_info(session_id, opts)
      return data
    end

    # application profiles in this application discovery session
    # Returns the application profiles that was part of the application discovery session | while it was started. 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(AppProfileListResult, Fixnum, Hash)>] AppProfileListResult data, response status code and response headers
    def get_app_discovery_session_app_profiles_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session_app_profiles ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session_app_profiles"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_app_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_app_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/app-profiles".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session_app_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns the details of the installed apps for the app profile ID in that session
    # Returns the details of the installed apps for the app profile ID in that session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :app_profile_id 
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :vm_id 
    # @return [AppInfoListResult]
    def get_app_discovery_session_installed_apps(session_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_installed_apps_with_http_info(session_id, opts)
      return data
    end

    # Returns the details of the installed apps for the app profile ID in that session
    # Returns the details of the installed apps for the app profile ID in that session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :app_profile_id 
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :vm_id 
    # @return [Array<(AppInfoListResult, Fixnum, Hash)>] AppInfoListResult data, response status code and response headers
    def get_app_discovery_session_installed_apps_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session_installed_apps ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session_installed_apps"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_installed_apps, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_installed_apps, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/installed-apps".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'app_profile_id'] = opts[:'app_profile_id'] if !opts[:'app_profile_id'].nil?
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'vm_id'] = opts[:'vm_id'] if !opts[:'vm_id'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppInfoListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session_installed_apps\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # vms in the ns-group of the application discovery session
    # Returns the vms in the ns-group of the application discovery session 
    # @param session_id 
    # @param ns_group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [AppDiscoveryVmInfoListResult]
    def get_app_discovery_session_ns_group_members(session_id, ns_group_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_ns_group_members_with_http_info(session_id, ns_group_id, opts)
      return data
    end

    # vms in the ns-group of the application discovery session
    # Returns the vms in the ns-group of the application discovery session 
    # @param session_id 
    # @param ns_group_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(AppDiscoveryVmInfoListResult, Fixnum, Hash)>] AppDiscoveryVmInfoListResult data, response status code and response headers
    def get_app_discovery_session_ns_group_members_with_http_info(session_id, ns_group_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session_ns_group_members ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session_ns_group_members"
      end
      # verify the required parameter 'ns_group_id' is set
      if @api_client.config.client_side_validation && ns_group_id.nil?
        fail ArgumentError, "Missing the required parameter 'ns_group_id' when calling AppDiscoveryApi.get_app_discovery_session_ns_group_members"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_ns_group_members, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_ns_group_members, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/ns-groups/{ns-group-id}/members".sub('{' + 'session-id' + '}', session_id.to_s).sub('{' + 'ns-group-id' + '}', ns_group_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoveryVmInfoListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session_ns_group_members\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # ns-groups in this application discovery session
    # Returns the ns groups that was part of the application discovery session | while it was started 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [NSGroupMetaInfoListResult]
    def get_app_discovery_session_ns_groups(session_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_ns_groups_with_http_info(session_id, opts)
      return data
    end

    # ns-groups in this application discovery session
    # Returns the ns groups that was part of the application discovery session | while it was started 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(NSGroupMetaInfoListResult, Fixnum, Hash)>] NSGroupMetaInfoListResult data, response status code and response headers
    def get_app_discovery_session_ns_groups_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session_ns_groups ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session_ns_groups"
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_ns_groups, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_session_ns_groups, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/ns-groups".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'NSGroupMetaInfoListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session_ns_groups\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns the summary of the application discovery session
    # Returns the summary of the application discovery session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [AppDiscoverySessionResultSummary]
    def get_app_discovery_session_summary(session_id, opts = {})
      data, _status_code, _headers = get_app_discovery_session_summary_with_http_info(session_id, opts)
      return data
    end

    # Returns the summary of the application discovery session
    # Returns the summary of the application discovery session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDiscoverySessionResultSummary, Fixnum, Hash)>] AppDiscoverySessionResultSummary data, response status code and response headers
    def get_app_discovery_session_summary_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_session_summary ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_app_discovery_session_summary"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/summary".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoverySessionResultSummary')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_session_summary\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns the list of the application discovery sessions available
    # Returns the list of the application discovery sessions available 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :group_id NSGroup id, helps user query sessions related to one nsgroup
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :status Session Status, e.g. get all running sessions
    # @return [AppDiscoverySessionsListResult]
    def get_app_discovery_sessions(opts = {})
      data, _status_code, _headers = get_app_discovery_sessions_with_http_info(opts)
      return data
    end

    # Returns the list of the application discovery sessions available
    # Returns the list of the application discovery sessions available 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :group_id NSGroup id, helps user query sessions related to one nsgroup
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @option opts [String] :status Session Status, e.g. get all running sessions
    # @return [Array<(AppDiscoverySessionsListResult, Fixnum, Hash)>] AppDiscoverySessionsListResult data, response status code and response headers
    def get_app_discovery_sessions_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_discovery_sessions ..."
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_sessions, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_discovery_sessions, must be greater than or equal to 0.'
      end

      if @api_client.config.client_side_validation && opts[:'status'] && !['STARTING', 'FAILED', 'RUNNING', 'FINISHED'].include?(opts[:'status'])
        fail ArgumentError, 'invalid value for "status", must be one of STARTING, FAILED, RUNNING, FINISHED'
      end
      # resource path
      local_var_path = "/app-discovery/sessions"

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'group_id'] = opts[:'group_id'] if !opts[:'group_id'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?
      query_params[:'status'] = opts[:'status'] if !opts[:'status'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoverySessionsListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_discovery_sessions\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns detail of the app profile
    # Returns detail of the app profile 
    # @param app_profile_id 
    # @param [Hash] opts the optional parameters
    # @return [AppProfile]
    def get_app_profile_details(app_profile_id, opts = {})
      data, _status_code, _headers = get_app_profile_details_with_http_info(app_profile_id, opts)
      return data
    end

    # Returns detail of the app profile
    # Returns detail of the app profile 
    # @param app_profile_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppProfile, Fixnum, Hash)>] AppProfile data, response status code and response headers
    def get_app_profile_details_with_http_info(app_profile_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_profile_details ..."
      end
      # verify the required parameter 'app_profile_id' is set
      if @api_client.config.client_side_validation && app_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_profile_id' when calling AppDiscoveryApi.get_app_profile_details"
      end
      # resource path
      local_var_path = "/app-discovery/app-profiles/{app-profile-id}".sub('{' + 'app-profile-id' + '}', app_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_profile_details\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Returns list of app profile IDs created
    # Returns list of app profile IDs created 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer) (default to 1000)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [AppProfileListResult]
    def get_app_profiles(opts = {})
      data, _status_code, _headers = get_app_profiles_with_http_info(opts)
      return data
    end

    # Returns list of app profile IDs created
    # Returns list of app profile IDs created 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :cursor Opaque cursor to be used for getting next page of records (supplied by current result page)
    # @option opts [String] :included_fields Comma separated list of fields that should be included in query result
    # @option opts [Integer] :page_size Maximum number of results to return in this page (server may return fewer)
    # @option opts [BOOLEAN] :sort_ascending 
    # @option opts [String] :sort_by Field by which records are sorted
    # @return [Array<(AppProfileListResult, Fixnum, Hash)>] AppProfileListResult data, response status code and response headers
    def get_app_profiles_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_app_profiles ..."
      end
      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] > 1000
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_profiles, must be smaller than or equal to 1000.'
      end

      if @api_client.config.client_side_validation && !opts[:'page_size'].nil? && opts[:'page_size'] < 0
        fail ArgumentError, 'invalid value for "opts[:"page_size"]" when calling AppDiscoveryApi.get_app_profiles, must be greater than or equal to 0.'
      end

      # resource path
      local_var_path = "/app-discovery/app-profiles"

      # query parameters
      query_params = {}
      query_params[:'cursor'] = opts[:'cursor'] if !opts[:'cursor'].nil?
      query_params[:'included_fields'] = opts[:'included_fields'] if !opts[:'included_fields'].nil?
      query_params[:'page_size'] = opts[:'page_size'] if !opts[:'page_size'].nil?
      query_params[:'sort_ascending'] = opts[:'sort_ascending'] if !opts[:'sort_ascending'].nil?
      query_params[:'sort_by'] = opts[:'sort_by'] if !opts[:'sort_by'].nil?

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfileListResult')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_app_profiles\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Export app discovery results in CSV format
    # Returns app discovery results in CSV format, each row contains discovered app information and the id of the vms this app is discovered from for a given set of vms (or for all vms belong to this session when no vm id is passed in) 
    # @param session_id 
    # @param report_app_results_for_vms_request_parameters 
    # @param [Hash] opts the optional parameters
    # @return [AppInfoHostVmListInCsvFormat]
    def get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv(session_id, report_app_results_for_vms_request_parameters, opts = {})
      data, _status_code, _headers = get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv_with_http_info(session_id, report_app_results_for_vms_request_parameters, opts)
      return data
    end

    # Export app discovery results in CSV format
    # Returns app discovery results in CSV format, each row contains discovered app information and the id of the vms this app is discovered from for a given set of vms (or for all vms belong to this session when no vm id is passed in) 
    # @param session_id 
    # @param report_app_results_for_vms_request_parameters 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppInfoHostVmListInCsvFormat, Fixnum, Hash)>] AppInfoHostVmListInCsvFormat data, response status code and response headers
    def get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv_with_http_info(session_id, report_app_results_for_vms_request_parameters, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv"
      end
      # verify the required parameter 'report_app_results_for_vms_request_parameters' is set
      if @api_client.config.client_side_validation && report_app_results_for_vms_request_parameters.nil?
        fail ArgumentError, "Missing the required parameter 'report_app_results_for_vms_request_parameters' when calling AppDiscoveryApi.get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/report/app-info-and-vm?format=csv".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['text/csv'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(report_app_results_for_vms_request_parameters)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppInfoHostVmListInCsvFormat')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_appdiscovery_result_app_info_and_host_vm_in_csv_format_csv\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Export app profiles in CSV format for a given sessiom
    # Returns app profiles information for a given session in CSV format Each row will contain detailed info of an app profile, and the id of apps which is member of this app profile in this session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [AppProfileMemberAppsListInCsvFormat]
    def get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv(session_id, opts = {})
      data, _status_code, _headers = get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv_with_http_info(session_id, opts)
      return data
    end

    # Export app profiles in CSV format for a given sessiom
    # Returns app profiles information for a given session in CSV format Each row will contain detailed info of an app profile, and the id of apps which is member of this app profile in this session 
    # @param session_id 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppProfileMemberAppsListInCsvFormat, Fixnum, Hash)>] AppProfileMemberAppsListInCsvFormat data, response status code and response headers
    def get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv_with_http_info(session_id, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/report/app-profile-and-app-info?format=csv".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['text/csv'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = nil
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:GET, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfileMemberAppsListInCsvFormat')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#get_appdiscovery_session_app_profile_member_apps_in_csv_format_csv\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Re-classify a completed application discovery session.
    # Re-classify completed application discovery session against input  AppProfiles. If no AppProfiles are specified then we use the previous  AppProfiles of that session. 
    # @param session_id 
    # @param session_reclassification_parameter 
    # @param [Hash] opts the optional parameters
    # @return [AppDiscoverySessionResultSummary]
    def reclassify_app_discovery_session(session_id, session_reclassification_parameter, opts = {})
      data, _status_code, _headers = reclassify_app_discovery_session_with_http_info(session_id, session_reclassification_parameter, opts)
      return data
    end

    # Re-classify a completed application discovery session.
    # Re-classify completed application discovery session against input  AppProfiles. If no AppProfiles are specified then we use the previous  AppProfiles of that session. 
    # @param session_id 
    # @param session_reclassification_parameter 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDiscoverySessionResultSummary, Fixnum, Hash)>] AppDiscoverySessionResultSummary data, response status code and response headers
    def reclassify_app_discovery_session_with_http_info(session_id, session_reclassification_parameter, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.reclassify_app_discovery_session ..."
      end
      # verify the required parameter 'session_id' is set
      if @api_client.config.client_side_validation && session_id.nil?
        fail ArgumentError, "Missing the required parameter 'session_id' when calling AppDiscoveryApi.reclassify_app_discovery_session"
      end
      # verify the required parameter 'session_reclassification_parameter' is set
      if @api_client.config.client_side_validation && session_reclassification_parameter.nil?
        fail ArgumentError, "Missing the required parameter 'session_reclassification_parameter' when calling AppDiscoveryApi.reclassify_app_discovery_session"
      end
      # resource path
      local_var_path = "/app-discovery/sessions/{session-id}/re-classify".sub('{' + 'session-id' + '}', session_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(session_reclassification_parameter)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoverySessionResultSummary')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#reclassify_app_discovery_session\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Starts the discovery of application discovery session
    # Starts the discovery of application discovery session 
    # @param start_app_discovery_session_parameters 
    # @param [Hash] opts the optional parameters
    # @return [AppDiscoverySession]
    def start_app_discovery_session(start_app_discovery_session_parameters, opts = {})
      data, _status_code, _headers = start_app_discovery_session_with_http_info(start_app_discovery_session_parameters, opts)
      return data
    end

    # Starts the discovery of application discovery session
    # Starts the discovery of application discovery session 
    # @param start_app_discovery_session_parameters 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppDiscoverySession, Fixnum, Hash)>] AppDiscoverySession data, response status code and response headers
    def start_app_discovery_session_with_http_info(start_app_discovery_session_parameters, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.start_app_discovery_session ..."
      end
      # verify the required parameter 'start_app_discovery_session_parameters' is set
      if @api_client.config.client_side_validation && start_app_discovery_session_parameters.nil?
        fail ArgumentError, "Missing the required parameter 'start_app_discovery_session_parameters' when calling AppDiscoveryApi.start_app_discovery_session"
      end
      # resource path
      local_var_path = "/app-discovery/sessions"

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(start_app_discovery_session_parameters)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:POST, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppDiscoverySession')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#start_app_discovery_session\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update AppProfile
    # Update AppProfile 
    # @param app_profile_id 
    # @param app_profile 
    # @param [Hash] opts the optional parameters
    # @return [AppProfile]
    def update_app_profile(app_profile_id, app_profile, opts = {})
      data, _status_code, _headers = update_app_profile_with_http_info(app_profile_id, app_profile, opts)
      return data
    end

    # Update AppProfile
    # Update AppProfile 
    # @param app_profile_id 
    # @param app_profile 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AppProfile, Fixnum, Hash)>] AppProfile data, response status code and response headers
    def update_app_profile_with_http_info(app_profile_id, app_profile, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug "Calling API: AppDiscoveryApi.update_app_profile ..."
      end
      # verify the required parameter 'app_profile_id' is set
      if @api_client.config.client_side_validation && app_profile_id.nil?
        fail ArgumentError, "Missing the required parameter 'app_profile_id' when calling AppDiscoveryApi.update_app_profile"
      end
      # verify the required parameter 'app_profile' is set
      if @api_client.config.client_side_validation && app_profile.nil?
        fail ArgumentError, "Missing the required parameter 'app_profile' when calling AppDiscoveryApi.update_app_profile"
      end
      # resource path
      local_var_path = "/app-discovery/app-profiles/{app-profile-id}".sub('{' + 'app-profile-id' + '}', app_profile_id.to_s)

      # query parameters
      query_params = {}

      # header parameters
      header_params = {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json'])

      # form parameters
      form_params = {}

      # http body (model)
      post_body = @api_client.object_to_http_body(app_profile)
      auth_names = ['BasicAuth']
      data, status_code, headers = @api_client.call_api(:PUT, local_var_path,
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => 'AppProfile')
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: AppDiscoveryApi#update_app_profile\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
