=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.3.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # This type contains the attributes and status of a group.
  class ClusterGroupStatus
    # Array of group members and their statuses
    attr_accessor :members

    # UUID of the group
    attr_accessor :group_id

    # Array of group leaders and their attributes
    attr_accessor :leaders

    # Group status
    attr_accessor :group_status

    # Type of the group
    attr_accessor :group_type

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'members' => :'members',
        :'group_id' => :'group_id',
        :'leaders' => :'leaders',
        :'group_status' => :'group_status',
        :'group_type' => :'group_type'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'members' => :'Array<ClusterGroupMemberStatus>',
        :'group_id' => :'String',
        :'leaders' => :'Array<ClusterGroupServiceLeader>',
        :'group_status' => :'String',
        :'group_type' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'members')
        if (value = attributes[:'members']).is_a?(Array)
          self.members = value
        end
      end

      if attributes.has_key?(:'group_id')
        self.group_id = attributes[:'group_id']
      end

      if attributes.has_key?(:'leaders')
        if (value = attributes[:'leaders']).is_a?(Array)
          self.leaders = value
        end
      end

      if attributes.has_key?(:'group_status')
        self.group_status = attributes[:'group_status']
      end

      if attributes.has_key?(:'group_type')
        self.group_type = attributes[:'group_type']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      group_status_validator = EnumAttributeValidator.new('String', ["STABLE", "DEGRADED", "UNSTABLE", "UNAVAILABLE"])
      return false unless group_status_validator.valid?(@group_status)
      group_type_validator = EnumAttributeValidator.new('String', ["MANAGER", "CONTROLLER", "POLICY", "HTTP"])
      return false unless group_type_validator.valid?(@group_type)
      return true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] group_status Object to be assigned
    def group_status=(group_status)
      validator = EnumAttributeValidator.new('String', ["STABLE", "DEGRADED", "UNSTABLE", "UNAVAILABLE"])
      unless validator.valid?(group_status)
        fail ArgumentError, "invalid value for 'group_status', must be one of #{validator.allowable_values}."
      end
      @group_status = group_status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] group_type Object to be assigned
    def group_type=(group_type)
      validator = EnumAttributeValidator.new('String', ["MANAGER", "CONTROLLER", "POLICY", "HTTP"])
      unless validator.valid?(group_type)
        fail ArgumentError, "invalid value for 'group_type', must be one of #{validator.allowable_values}."
      end
      @group_type = group_type
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          members == o.members &&
          group_id == o.group_id &&
          leaders == o.leaders &&
          group_status == o.group_status &&
          group_type == o.group_type
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [members, group_id, leaders, group_status, group_type].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
