=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.3.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # The information for a given load balancer service could be used for debugging and troubleshooting. It includes load balancer service, associated virtual servers, associated pools, associated profiles such as persistence, SSL, application, associated monitors and associated rules. 
  class LbServiceDebugInfo
    # The pools which are associated to the given load balancer service would be included. The pools could be defined in virtual server default pool, sorry pool or load balancer rule action. 
    attr_accessor :pools

    # The TCP profiles are associated to virtual servers 
    attr_accessor :tcp_profiles

    # The virtual servers which are associated to the given load balancer service would be included. 
    attr_accessor :virtual_servers

    # The client SSL profiles are associated to virtual servers 
    attr_accessor :client_ssl_profiles

    # The server SSL profiles are associated to virtual servers 
    attr_accessor :server_ssl_profiles

    # Load balancer service setting for a given load balancer service identifier. 
    attr_accessor :service

    # The load balancer rules are associated to virtual servers 
    attr_accessor :rules

    # The application profiles are associated to virtual servers 
    attr_accessor :application_profiles

    # The persistence profiles are associated to virtual servers 
    attr_accessor :persistence_profiles

    # The load balancer monitors are associated to pools. 
    attr_accessor :monitors


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'pools' => :'pools',
        :'tcp_profiles' => :'tcp_profiles',
        :'virtual_servers' => :'virtual_servers',
        :'client_ssl_profiles' => :'client_ssl_profiles',
        :'server_ssl_profiles' => :'server_ssl_profiles',
        :'service' => :'service',
        :'rules' => :'rules',
        :'application_profiles' => :'application_profiles',
        :'persistence_profiles' => :'persistence_profiles',
        :'monitors' => :'monitors'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'pools' => :'Array<LbPool>',
        :'tcp_profiles' => :'Array<LbTcpProfile>',
        :'virtual_servers' => :'Array<LbVirtualServer>',
        :'client_ssl_profiles' => :'Array<LbClientSslProfile>',
        :'server_ssl_profiles' => :'Array<LbServerSslProfile>',
        :'service' => :'LbService',
        :'rules' => :'Array<LbRule>',
        :'application_profiles' => :'Array<LbAppProfile>',
        :'persistence_profiles' => :'Array<LbPersistenceProfile>',
        :'monitors' => :'Array<LbMonitor>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'pools')
        if (value = attributes[:'pools']).is_a?(Array)
          self.pools = value
        end
      end

      if attributes.has_key?(:'tcp_profiles')
        if (value = attributes[:'tcp_profiles']).is_a?(Array)
          self.tcp_profiles = value
        end
      end

      if attributes.has_key?(:'virtual_servers')
        if (value = attributes[:'virtual_servers']).is_a?(Array)
          self.virtual_servers = value
        end
      end

      if attributes.has_key?(:'client_ssl_profiles')
        if (value = attributes[:'client_ssl_profiles']).is_a?(Array)
          self.client_ssl_profiles = value
        end
      end

      if attributes.has_key?(:'server_ssl_profiles')
        if (value = attributes[:'server_ssl_profiles']).is_a?(Array)
          self.server_ssl_profiles = value
        end
      end

      if attributes.has_key?(:'service')
        self.service = attributes[:'service']
      end

      if attributes.has_key?(:'rules')
        if (value = attributes[:'rules']).is_a?(Array)
          self.rules = value
        end
      end

      if attributes.has_key?(:'application_profiles')
        if (value = attributes[:'application_profiles']).is_a?(Array)
          self.application_profiles = value
        end
      end

      if attributes.has_key?(:'persistence_profiles')
        if (value = attributes[:'persistence_profiles']).is_a?(Array)
          self.persistence_profiles = value
        end
      end

      if attributes.has_key?(:'monitors')
        if (value = attributes[:'monitors']).is_a?(Array)
          self.monitors = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          pools == o.pools &&
          tcp_profiles == o.tcp_profiles &&
          virtual_servers == o.virtual_servers &&
          client_ssl_profiles == o.client_ssl_profiles &&
          server_ssl_profiles == o.server_ssl_profiles &&
          service == o.service &&
          rules == o.rules &&
          application_profiles == o.application_profiles &&
          persistence_profiles == o.persistence_profiles &&
          monitors == o.monitors
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [pools, tcp_profiles, virtual_servers, client_ssl_profiles, server_ssl_profiles, service, rules, application_profiles, persistence_profiles, monitors].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
