=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.3.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # The deployment of a registered service. Service instance is instantiation of service. It is the most used type of instance. It is a default instance to be used when NSX handles lifecycle of appliance. Deployment and appliance related all the information is necessary.
  class ServiceInstance
    # Link to this resource
    attr_accessor :_self

    # The server will populate this field when returing the resource. Ignored on PUT and POST.
    attr_accessor :_links

    # Schema for this resource
    attr_accessor :_schema

    # The _revision property describes the current revision of the resource. To prevent clients from overwriting each other's changes, PUT operations must include the current _revision of the resource, which clients should obtain by issuing a GET operation. If the _revision provided in a PUT request is missing or stale, the operation will be rejected.
    attr_accessor :_revision

    # Indicates system owned resource
    attr_accessor :_system_owned

    # Defaults to ID if not set
    attr_accessor :display_name

    # Description of this resource
    attr_accessor :description

    # Opaque identifiers meaningful to the API user
    attr_accessor :tags

    # ID of the user who created this resource
    attr_accessor :_create_user

    # Protection status is one of the following: PROTECTED - the client who retrieved the entity is not allowed             to modify it. NOT_PROTECTED - the client who retrieved the entity is allowed                 to modify it REQUIRE_OVERRIDE - the client who retrieved the entity is a super                    user and can modify it, but only when providing                    the request header X-Allow-Overwrite=true. UNKNOWN - the _protection field could not be determined for this           entity. 
    attr_accessor :_protection

    # Timestamp of resource creation
    attr_accessor :_create_time

    # Timestamp of last modification
    attr_accessor :_last_modified_time

    # ID of the user who last modified this resource
    attr_accessor :_last_modified_user

    # Unique identifier of this resource
    attr_accessor :id

    # ServiceInstance is used when NSX handles the lifecyle of   appliance. Deployment and appliance related all the information is necessary. ByodServiceInstance is a custom instance to be used when NSX is not handling   the lifecycles of appliance/s. User will manage their own appliance (BYOD)   to connect with NSX. VirtualServiceInstance is a a custom instance to be used when NSX is not   handling the lifecycle of an appliance and when the user is not bringing   their own appliance. 
    attr_accessor :resource_type

    # Failure policy of the service instance - if it has to be different from the service. By default the service instance inherits the FailurePolicy of the service it belongs to.
    attr_accessor :on_failure_policy

    # Transport to be used by this service instance for deploying the Service-VM.
    attr_accessor :transport_type

    # The Service to which the service instance is associated.
    attr_accessor :service_id

    # Name of the deployment spec to be used by this service instance.
    attr_accessor :deployment_spec_name

    # Implementation to be used by this service instance for deploying the Service-VM.
    attr_accessor :implementation_type

    # The deployment template to be used by this service instance. The attribute values specific to this instance can be added.
    attr_accessor :instance_deployment_template

    # Attachment point to be used by this service instance for deploying the Service-VM.
    attr_accessor :attachment_point

    # Instance Deployment Config contains the information to be injected during Service-VM deployment.
    attr_accessor :instance_deployment_config

    # Deployment mode specifies where the partner appliance will be deployed in HA or non-HA i.e standalone mode.
    attr_accessor :deployment_mode

    # List of resource references where service instance be deployed. Ex. Tier 0 Logical Router in case of N-S ServiceInsertion.
    attr_accessor :deployed_to

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'_self' => :'_self',
        :'_links' => :'_links',
        :'_schema' => :'_schema',
        :'_revision' => :'_revision',
        :'_system_owned' => :'_system_owned',
        :'display_name' => :'display_name',
        :'description' => :'description',
        :'tags' => :'tags',
        :'_create_user' => :'_create_user',
        :'_protection' => :'_protection',
        :'_create_time' => :'_create_time',
        :'_last_modified_time' => :'_last_modified_time',
        :'_last_modified_user' => :'_last_modified_user',
        :'id' => :'id',
        :'resource_type' => :'resource_type',
        :'on_failure_policy' => :'on_failure_policy',
        :'transport_type' => :'transport_type',
        :'service_id' => :'service_id',
        :'deployment_spec_name' => :'deployment_spec_name',
        :'implementation_type' => :'implementation_type',
        :'instance_deployment_template' => :'instance_deployment_template',
        :'attachment_point' => :'attachment_point',
        :'instance_deployment_config' => :'instance_deployment_config',
        :'deployment_mode' => :'deployment_mode',
        :'deployed_to' => :'deployed_to'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'_self' => :'SelfResourceLink',
        :'_links' => :'Array<ResourceLink>',
        :'_schema' => :'String',
        :'_revision' => :'Integer',
        :'_system_owned' => :'BOOLEAN',
        :'display_name' => :'String',
        :'description' => :'String',
        :'tags' => :'Array<Tag>',
        :'_create_user' => :'String',
        :'_protection' => :'String',
        :'_create_time' => :'Integer',
        :'_last_modified_time' => :'Integer',
        :'_last_modified_user' => :'String',
        :'id' => :'String',
        :'resource_type' => :'String',
        :'on_failure_policy' => :'String',
        :'transport_type' => :'String',
        :'service_id' => :'String',
        :'deployment_spec_name' => :'String',
        :'implementation_type' => :'String',
        :'instance_deployment_template' => :'DeploymentTemplate',
        :'attachment_point' => :'String',
        :'instance_deployment_config' => :'InstanceDeploymentConfig',
        :'deployment_mode' => :'String',
        :'deployed_to' => :'Array<ResourceReference>'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'_self')
        self._self = attributes[:'_self']
      end

      if attributes.has_key?(:'_links')
        if (value = attributes[:'_links']).is_a?(Array)
          self._links = value
        end
      end

      if attributes.has_key?(:'_schema')
        self._schema = attributes[:'_schema']
      end

      if attributes.has_key?(:'_revision')
        self._revision = attributes[:'_revision']
      end

      if attributes.has_key?(:'_system_owned')
        self._system_owned = attributes[:'_system_owned']
      end

      if attributes.has_key?(:'display_name')
        self.display_name = attributes[:'display_name']
      end

      if attributes.has_key?(:'description')
        self.description = attributes[:'description']
      end

      if attributes.has_key?(:'tags')
        if (value = attributes[:'tags']).is_a?(Array)
          self.tags = value
        end
      end

      if attributes.has_key?(:'_create_user')
        self._create_user = attributes[:'_create_user']
      end

      if attributes.has_key?(:'_protection')
        self._protection = attributes[:'_protection']
      end

      if attributes.has_key?(:'_create_time')
        self._create_time = attributes[:'_create_time']
      end

      if attributes.has_key?(:'_last_modified_time')
        self._last_modified_time = attributes[:'_last_modified_time']
      end

      if attributes.has_key?(:'_last_modified_user')
        self._last_modified_user = attributes[:'_last_modified_user']
      end

      if attributes.has_key?(:'id')
        self.id = attributes[:'id']
      end

      if attributes.has_key?(:'resource_type')
        self.resource_type = attributes[:'resource_type']
      end

      if attributes.has_key?(:'on_failure_policy')
        self.on_failure_policy = attributes[:'on_failure_policy']
      end

      if attributes.has_key?(:'transport_type')
        self.transport_type = attributes[:'transport_type']
      end

      if attributes.has_key?(:'service_id')
        self.service_id = attributes[:'service_id']
      end

      if attributes.has_key?(:'deployment_spec_name')
        self.deployment_spec_name = attributes[:'deployment_spec_name']
      end

      if attributes.has_key?(:'implementation_type')
        self.implementation_type = attributes[:'implementation_type']
      end

      if attributes.has_key?(:'instance_deployment_template')
        self.instance_deployment_template = attributes[:'instance_deployment_template']
      end

      if attributes.has_key?(:'attachment_point')
        self.attachment_point = attributes[:'attachment_point']
      end

      if attributes.has_key?(:'instance_deployment_config')
        self.instance_deployment_config = attributes[:'instance_deployment_config']
      end

      if attributes.has_key?(:'deployment_mode')
        self.deployment_mode = attributes[:'deployment_mode']
      else
        self.deployment_mode = "ACTIVE_STANDBY"
      end

      if attributes.has_key?(:'deployed_to')
        if (value = attributes[:'deployed_to']).is_a?(Array)
          self.deployed_to = value
        end
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if !@display_name.nil? && @display_name.to_s.length > 255
        invalid_properties.push("invalid value for 'display_name', the character length must be smaller than or equal to 255.")
      end

      if !@description.nil? && @description.to_s.length > 1024
        invalid_properties.push("invalid value for 'description', the character length must be smaller than or equal to 1024.")
      end

      if @resource_type.nil?
        invalid_properties.push("invalid value for 'resource_type', resource_type cannot be nil.")
      end

      if @transport_type.nil?
        invalid_properties.push("invalid value for 'transport_type', transport_type cannot be nil.")
      end

      if @deployment_spec_name.nil?
        invalid_properties.push("invalid value for 'deployment_spec_name', deployment_spec_name cannot be nil.")
      end

      if @implementation_type.nil?
        invalid_properties.push("invalid value for 'implementation_type', implementation_type cannot be nil.")
      end

      if @instance_deployment_template.nil?
        invalid_properties.push("invalid value for 'instance_deployment_template', instance_deployment_template cannot be nil.")
      end

      if @attachment_point.nil?
        invalid_properties.push("invalid value for 'attachment_point', attachment_point cannot be nil.")
      end

      if @instance_deployment_config.nil?
        invalid_properties.push("invalid value for 'instance_deployment_config', instance_deployment_config cannot be nil.")
      end

      if @deployment_mode.nil?
        invalid_properties.push("invalid value for 'deployment_mode', deployment_mode cannot be nil.")
      end

      if @deployed_to.nil?
        invalid_properties.push("invalid value for 'deployed_to', deployed_to cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if !@display_name.nil? && @display_name.to_s.length > 255
      return false if !@description.nil? && @description.to_s.length > 1024
      return false if @resource_type.nil?
      resource_type_validator = EnumAttributeValidator.new('String', ["ServiceInstance", "ByodServiceInstance", "VirtualServiceInstance"])
      return false unless resource_type_validator.valid?(@resource_type)
      on_failure_policy_validator = EnumAttributeValidator.new('String', ["ALLOW", "BLOCK"])
      return false unless on_failure_policy_validator.valid?(@on_failure_policy)
      return false if @transport_type.nil?
      transport_type_validator = EnumAttributeValidator.new('String', ["L2_BRIDGE", "L3_ROUTED"])
      return false unless transport_type_validator.valid?(@transport_type)
      return false if @deployment_spec_name.nil?
      return false if @implementation_type.nil?
      implementation_type_validator = EnumAttributeValidator.new('String', ["NORTH_SOUTH", "EAST_WEST"])
      return false unless implementation_type_validator.valid?(@implementation_type)
      return false if @instance_deployment_template.nil?
      return false if @attachment_point.nil?
      attachment_point_validator = EnumAttributeValidator.new('String', ["TIER0_LR", "TIER1_LR"])
      return false unless attachment_point_validator.valid?(@attachment_point)
      return false if @instance_deployment_config.nil?
      return false if @deployment_mode.nil?
      deployment_mode_validator = EnumAttributeValidator.new('String', ["STAND_ALONE", "ACTIVE_STANDBY"])
      return false unless deployment_mode_validator.valid?(@deployment_mode)
      return false if @deployed_to.nil?
      return true
    end

    # Custom attribute writer method with validation
    # @param [Object] display_name Value to be assigned
    def display_name=(display_name)

      if !display_name.nil? && display_name.to_s.length > 255
        fail ArgumentError, "invalid value for 'display_name', the character length must be smaller than or equal to 255."
      end

      @display_name = display_name
    end

    # Custom attribute writer method with validation
    # @param [Object] description Value to be assigned
    def description=(description)

      if !description.nil? && description.to_s.length > 1024
        fail ArgumentError, "invalid value for 'description', the character length must be smaller than or equal to 1024."
      end

      @description = description
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] resource_type Object to be assigned
    def resource_type=(resource_type)
      validator = EnumAttributeValidator.new('String', ["ServiceInstance", "ByodServiceInstance", "VirtualServiceInstance"])
      unless validator.valid?(resource_type)
        fail ArgumentError, "invalid value for 'resource_type', must be one of #{validator.allowable_values}."
      end
      @resource_type = resource_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] on_failure_policy Object to be assigned
    def on_failure_policy=(on_failure_policy)
      validator = EnumAttributeValidator.new('String', ["ALLOW", "BLOCK"])
      unless validator.valid?(on_failure_policy)
        fail ArgumentError, "invalid value for 'on_failure_policy', must be one of #{validator.allowable_values}."
      end
      @on_failure_policy = on_failure_policy
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] transport_type Object to be assigned
    def transport_type=(transport_type)
      validator = EnumAttributeValidator.new('String', ["L2_BRIDGE", "L3_ROUTED"])
      unless validator.valid?(transport_type)
        fail ArgumentError, "invalid value for 'transport_type', must be one of #{validator.allowable_values}."
      end
      @transport_type = transport_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] implementation_type Object to be assigned
    def implementation_type=(implementation_type)
      validator = EnumAttributeValidator.new('String', ["NORTH_SOUTH", "EAST_WEST"])
      unless validator.valid?(implementation_type)
        fail ArgumentError, "invalid value for 'implementation_type', must be one of #{validator.allowable_values}."
      end
      @implementation_type = implementation_type
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] attachment_point Object to be assigned
    def attachment_point=(attachment_point)
      validator = EnumAttributeValidator.new('String', ["TIER0_LR", "TIER1_LR"])
      unless validator.valid?(attachment_point)
        fail ArgumentError, "invalid value for 'attachment_point', must be one of #{validator.allowable_values}."
      end
      @attachment_point = attachment_point
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] deployment_mode Object to be assigned
    def deployment_mode=(deployment_mode)
      validator = EnumAttributeValidator.new('String', ["STAND_ALONE", "ACTIVE_STANDBY"])
      unless validator.valid?(deployment_mode)
        fail ArgumentError, "invalid value for 'deployment_mode', must be one of #{validator.allowable_values}."
      end
      @deployment_mode = deployment_mode
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          _self == o._self &&
          _links == o._links &&
          _schema == o._schema &&
          _revision == o._revision &&
          _system_owned == o._system_owned &&
          display_name == o.display_name &&
          description == o.description &&
          tags == o.tags &&
          _create_user == o._create_user &&
          _protection == o._protection &&
          _create_time == o._create_time &&
          _last_modified_time == o._last_modified_time &&
          _last_modified_user == o._last_modified_user &&
          id == o.id &&
          resource_type == o.resource_type &&
          on_failure_policy == o.on_failure_policy &&
          transport_type == o.transport_type &&
          service_id == o.service_id &&
          deployment_spec_name == o.deployment_spec_name &&
          implementation_type == o.implementation_type &&
          instance_deployment_template == o.instance_deployment_template &&
          attachment_point == o.attachment_point &&
          instance_deployment_config == o.instance_deployment_config &&
          deployment_mode == o.deployment_mode &&
          deployed_to == o.deployed_to
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [_self, _links, _schema, _revision, _system_owned, display_name, description, tags, _create_user, _protection, _create_time, _last_modified_time, _last_modified_user, id, resource_type, on_failure_policy, transport_type, service_id, deployment_spec_name, implementation_type, instance_deployment_template, attachment_point, instance_deployment_config, deployment_mode, deployed_to].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
