=begin
#NSX-T Manager API

#VMware NSX-T Manager REST API

OpenAPI spec version: 2.3.0.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.3.1

=end

require 'date'

module NSXT
  # Structured data entry in RFC5424 log format
  class StructuredData
    # Audit flag of the log
    attr_accessor :audit

    # Username value of the log
    attr_accessor :username

    # External request Id value of the log
    attr_accessor :ereq_id

    # Level value of the log
    attr_accessor :level

    # Component value of the log
    attr_accessor :comp

    # Error Code value of the log
    attr_accessor :error_code

    # Sub-subcomponent value of the log
    attr_accessor :s2comp

    # Request Id value of the log
    attr_accessor :req_id

    # Entity Id value of the log
    attr_accessor :ent_id

    # Security flag of the log
    attr_accessor :security

    # Subcomponent value of the log
    attr_accessor :subcomp


    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'audit' => :'audit',
        :'username' => :'username',
        :'ereq_id' => :'ereq_id',
        :'level' => :'level',
        :'comp' => :'comp',
        :'error_code' => :'error_code',
        :'s2comp' => :'s2comp',
        :'req_id' => :'req_id',
        :'ent_id' => :'ent_id',
        :'security' => :'security',
        :'subcomp' => :'subcomp'
      }
    end

    # Attribute type mapping.
    def self.swagger_types
      {
        :'audit' => :'String',
        :'username' => :'String',
        :'ereq_id' => :'String',
        :'level' => :'String',
        :'comp' => :'String',
        :'error_code' => :'String',
        :'s2comp' => :'String',
        :'req_id' => :'String',
        :'ent_id' => :'String',
        :'security' => :'String',
        :'subcomp' => :'String'
      }
    end

    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      return unless attributes.is_a?(Hash)

      # convert string to symbol for hash key
      attributes = attributes.each_with_object({}){|(k,v), h| h[k.to_sym] = v}

      if attributes.has_key?(:'audit')
        self.audit = attributes[:'audit']
      end

      if attributes.has_key?(:'username')
        self.username = attributes[:'username']
      end

      if attributes.has_key?(:'ereq_id')
        self.ereq_id = attributes[:'ereq_id']
      end

      if attributes.has_key?(:'level')
        self.level = attributes[:'level']
      end

      if attributes.has_key?(:'comp')
        self.comp = attributes[:'comp']
      end

      if attributes.has_key?(:'error_code')
        self.error_code = attributes[:'error_code']
      end

      if attributes.has_key?(:'s2comp')
        self.s2comp = attributes[:'s2comp']
      end

      if attributes.has_key?(:'req_id')
        self.req_id = attributes[:'req_id']
      end

      if attributes.has_key?(:'ent_id')
        self.ent_id = attributes[:'ent_id']
      end

      if attributes.has_key?(:'security')
        self.security = attributes[:'security']
      end

      if attributes.has_key?(:'subcomp')
        self.subcomp = attributes[:'subcomp']
      end

    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      if @audit.nil?
        invalid_properties.push("invalid value for 'audit', audit cannot be nil.")
      end

      if @comp.nil?
        invalid_properties.push("invalid value for 'comp', comp cannot be nil.")
      end

      if @subcomp.nil?
        invalid_properties.push("invalid value for 'subcomp', subcomp cannot be nil.")
      end

      return invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      return false if @audit.nil?
      return false if @comp.nil?
      return false if @subcomp.nil?
      return true
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          audit == o.audit &&
          username == o.username &&
          ereq_id == o.ereq_id &&
          level == o.level &&
          comp == o.comp &&
          error_code == o.error_code &&
          s2comp == o.s2comp &&
          req_id == o.req_id &&
          ent_id == o.ent_id &&
          security == o.security &&
          subcomp == o.subcomp
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Fixnum] Hash code
    def hash
      [audit, username, ereq_id, level, comp, error_code, s2comp, req_id, ent_id, security, subcomp].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.swagger_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map{ |v| _deserialize($1, v) } )
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        end # or else data not found in attributes(hash), not an issue as the data can be optional
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :BOOLEAN
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        temp_model = NSXT.const_get(type).new
        temp_model.build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        next if value.nil?
        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map{ |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end

  end

end
